#!/usr/bin/env python2.7

#package name
LIBSVM = 'kernel-ranksvm'
SVM_LIGHT = 'svm-light'
SVM_RANK = 'svm-rank-1slack'
RV_SVM = 'rv-svm'

#package path
TRAIN_LOG = 0
TRAIN_LOG_TIME = 1
PACKAGE_PATH = {}
PACKAGE_PATH[LIBSVM] = {}
PACKAGE_PATH[SVM_LIGHT] = {}
PACKAGE_PATH[SVM_RANK] = {}
PACKAGE_PATH[RV_SVM] = {}

#libsvm
PACKAGE_PATH[LIBSVM][TRAIN_LOG] = "./kernel-ranksvm/svm-train-log"
PACKAGE_PATH[LIBSVM][TRAIN_LOG_TIME] = "./kernel-ranksvm/svm-train-log-time"
#svm-light
PACKAGE_PATH[SVM_LIGHT][TRAIN_LOG] = "./svm-light/svm_learn_log"
PACKAGE_PATH[SVM_LIGHT][TRAIN_LOG_TIME] = "./svm-light/svm_learn_log_time"
#svm-rank
PACKAGE_PATH[SVM_RANK][TRAIN_LOG] = "./svm-rank/svm_rank_learn_log"
PACKAGE_PATH[SVM_RANK][TRAIN_LOG_TIME] = "./svm-rank/svm_rank_learn_log_time"
#rv-svm
PACKAGE_PATH[RV_SVM][TRAIN_LOG] = "./rv-svm/rv-svm-log"
PACKAGE_PATH[RV_SVM][TRAIN_LOG_TIME] = "./rv-svm/rv-svm-log-time"

#datapath
DATA_PATH = {}
DATA_ROOT = "./data"
DATA_PATH["MQ2008"] = '/'.join([DATA_ROOT, 'MQ2008'])
DATA_PATH["MQ2007"] = '/'.join([DATA_ROOT, 'MQ2007'])
DATA_PATH["MQ2007-list"] = '/'.join([DATA_ROOT, 'MQ2007-list-sub'])


PARAMETER_DIR = "./parameter"
TARGETS = {}
NUMBER_OF_QUERY = {}
NUMBER_OF_QUERY["MQ2008"] = 471
NUMBER_OF_QUERY["MQ2007"] = 1017
NUMBER_OF_QUERY["MQ2007-list"] = 52
TARGETS["MQ2008"] = [LIBSVM, SVM_LIGHT, SVM_RANK, RV_SVM]
TARGETS["MQ2007"] = [LIBSVM, SVM_LIGHT, SVM_RANK]
TARGETS["MQ2007-list"] = [LIBSVM, SVM_LIGHT, SVM_RANK]
TASK_LIST = [["MQ2008", TARGETS["MQ2008"]]]
TASK_LIST += [["MQ2007", TARGETS["MQ2007"]]]
TASK_LIST += [["MQ2007-list", TARGETS["MQ2007-list"]]]
PA = "PA"
NDCG = "NDCG"
MAP = "MAP"
TARGET_METRIC = {}
TARGET_METRIC["MQ2008"] = [PA, NDCG, MAP]
TARGET_METRIC["MQ2008"] = [PA]
TARGET_METRIC["MQ2007"] = [PA, NDCG]
TARGET_METRIC["MQ2007-list"] = [PA]
METRIC = [PA, NDCG, MAP]
C = 'c'
G = 'g'

THRESHOLD = {}
THRESHOLD["MQ2007"] = 80
THRESHOLD["MQ2007-list"] = 80
THRESHOLD["MQ2008"] = 3
MAX = {}
MAX["MQ2007"] = 30000
MAX["MQ2007-list"] = 30000
MAX["MQ2008"] = 2000

EXP_LOG_DIR = './log'
PLOT_DIR = './plots'

#plot option
PLOT_OPTION = {}
PLOT_OPTION[LIBSVM] = '--b'
PLOT_OPTION[SVM_LIGHT] = '-g'
PLOT_OPTION[SVM_RANK] = '-.k'
PLOT_OPTION[RV_SVM] = '-m'

#metric description
METRIC_DESCIPTION = {}
METRIC_DESCIPTION[PA] = "Pairwise Accuracy"
METRIC_DESCIPTION[NDCG] = "Mean NDCG"
METRIC_DESCIPTION[MAP] = "Mean Average Precision"

#target description
TARGET_DESCRIPTION = {
		LIBSVM : "TRON",
		SVM_LIGHT : "SVM^{light}",
		SVM_RANK : "SVM^{rank}",
		RV_SVM : "RV-SVM"
}

