#ifndef _LOG_H_
#define _LOG_H_

#include <vector>
#include "svm.h"
class Logger
{
	public:
		Logger(const char* test_file_path, const svm_problem *problem, const svm_parameter &parameter);
		~Logger();
		void add_record(double *w, double time, double objvalue);
		void save(const char *file_path);


	protected:
		struct Metric
		{
			double time; //unit: seconds
			double average_pairwise_accuracy;
			double objective_function_value;
			double mean_ndcg;
			double mean_average_precision;
		};

		std::vector<struct Metric> m_records;
		struct svm_node **m_test_data;
		double *m_target_label;
		int *m_qid;
		double m_gamma;
		const svm_problem *m_problem;
		int m_test_data_size;
		double *m_decision_value;

		double get_decision_value(double *w, int index);
};

extern Logger *logger;
	

#endif
